#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include "/musr/macros/delmacros.h"

#define ARRSIZE 16384
#define SIZE 512

extern SFHEADER      sfdesc[NFILES];
 
float rvbarrayl[10000],rvbarrayr[10000],*arr,del[10],amp[10];
int l[2];

sroom(p,n_args)
float *p;

{
	long i,nsamps,n,k,count,outbytes,smps=0;
	int j,m,z,chans,channo=0;
	float val,ampall,*xin,out[ARRSIZE*2];
 	float rvbsig,delval,rout,lout;
        float reverb(),right(),left();
	extern int lineset;
	extern float array[SIZE],tabs[2];
	extern struct stat sfst[NFILES];

/* p0-insk; p1-outsk; p2-dur; p3-amp;  p4,p5-room dims(+x & +y);
   p6,p7-x,y of source p8-reverb time, p9-reflectivity, p10-inner rm width
   <p11-channel #>		*/

	if(sfchans(&sfdesc[1]) != 2) {
		printf("output file must be stereo\n");
		closesf();
		}

	if (p[2] == 0)
		p[2] = (float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
			 /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
			 /sfsrate(&sfdesc[0]);
	if(!lineset) {
		for(j = 0; j < SIZE; j++) array[j] = 1;
		fprintf(stderr,"Set phrase curve to all 1's\n");
		lineset = 1;
		}
        tableset(p[2], SIZE, tabs);

	if (n_args == 12) channo = p[11];
	chans = sfchans(&sfdesc[0]);
	if ((xin=(float *)malloc(ARRSIZE*chans*4)) == NULL) {
		fprintf(stderr,"error in allocating input array... sorry!\n");
		exit(-2);
		}

        setnote(p[0],p[2],0);
	nsamps = setnote(p[1],p[2],1);
        distndelset(p[6],p[7],p[4],p[5],p[10],p[8],p[9]);
	z = SR/100;
	ampall = p[3];
	j = 0;
        for (i = nsamps; i > 0; i -= ARRSIZE) {
		outbytes = count = (i < ARRSIZE) ? i : ARRSIZE;
		count *= chans;
		bgetin(xin,0,count);
		for (n = channo,k = 0; n < count; n += chans,k += 2) {
			while (!j--) {
				val = tablei(smps,array,tabs) * ampall;
				j = z;
				smps += z;
				}
			DELPUT((val*xin[n]),arr,l);
 
			rout = 0.;
			for (m = 1; m < 10; m += 2) {
				DELGET(arr,del[m],l,delval);
    				rout += delval * amp[m];
    				if (m < 2) rvbsig = -rout;
   				}
  			rvbsig += rout;
			out[k] = rout + reverb(rvbsig,rvbarrayr);

			lout = 0.;
			for (m = 0; m < 10; m += 2) {
				DELGET(arr,del[m],l,delval);
    				lout += delval * amp[m];
    				if (m < 2) rvbsig = -lout;
   				}
			rvbsig += lout;
		  	out[k+1] = lout + reverb(rvbsig,rvbarrayl);
			}
		baddout(out,1,outbytes*2);
		}

	nsamps = (long) p[8]*SR;
	for (i = nsamps; i > 0; i -= ARRSIZE) {
		count = (i < ARRSIZE) ? i : ARRSIZE;
		count *= 2;
		for (n = 0; n < count; n += 2) {
			DELPUT(0.,arr,l);
 
			rout = 0.;
			for (m = 1; m < 10; m += 2) {
				DELGET(arr,del[m],l,delval);
    				rout += delval * amp[m];
    				if (m < 2) rvbsig = -rout;
   				}
  			rvbsig += rout;
			out[n] = rout + reverb(rvbsig,rvbarrayr);

			lout = 0.;
			for (m = 0; m < 10; m += 2) {
				DELGET(arr,del[m],l,delval);
    				lout += delval * amp[m];
    				if (m < 2) rvbsig = -lout;
   				}
			rvbsig += lout;
			out[n+1] = lout + reverb(rvbsig,rvbarrayl);
			}
		baddout(out,1,count);
		}
	endnote(1);
}


distndelset(xsource,ysource,xouter,youter,inner,rvt,reflect)

float xsource,ysource,xouter,youter,inner,rvt,reflect;

{
	double dist[10];
 	int m,nmax,nsmps;

  	rvbset(rvt,0,rvbarrayl);
	rvbset(rvt,0,rvbarrayr);

	dist[0]=pow(((double)(xsource-inner)), 2.) + 
		pow(((double)(ysource-1.)), 2.);
	dist[1]=pow(((double)(xsource+inner)),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[2]=pow(((double)(xsource-inner)),2.) +
		pow(((double)(ysource-1. + 2.*(youter-ysource))),2.);
	dist[3]=pow(((double)(xsource+inner)),2.) +
		pow(((double)(ysource-1. + 2.*(youter-ysource))),2.);
	dist[4]=pow((xsource-inner +2.*(xouter-xsource)),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[5]=pow(((double)(xsource+inner +2.*(xouter-xsource))),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[6]=pow(((double)(xsource-inner)),2.) +
		pow(((double)(ysource-1. - 2.*(youter+ysource))),2.);
	dist[7]=pow(((double)(xsource+inner)),2.) +
		pow(((double)(ysource-1. - 2.*(youter+ysource))),2.);
	dist[8]=pow(((double)(xsource-inner - 2.*(xouter+xsource))),2.) +
		pow(((double)(ysource-1.)),2.);
	dist[9]=pow(((double)(xsource+inner - 2.*(xouter+xsource))),2.) +
		pow(((double)(ysource-1.)),2.);

	nmax = 0;
	for (m = 0; m < 10; m++) {
		dist[m] = sqrt(dist[m]);
    		del[m] = (float) (dist[m]/1086.);
    		amp[m] = (float) ((dist[m]-dist[0])/dist[0] * (-6.));
   		amp[m] = (float) (pow(10.,(((double) amp[m])/20.)));
    		nsmps = del[m] * SR + .5;
    		nmax = (nsmps > nmax) ? nsmps : nmax;
    		if (m > 2) {
      			amp[m] = amp[m] * reflect/100.;
      			}
    		}

	if ((arr = (float *)realloc( (char *)arr, nmax*FLOAT) ) == NULL) {
		fprintf(stderr,"Sorry, Charlie -- no space\n");
		exit(1);
		}

   	delset(arr,l,((float) (nmax/SR)));
   	if (!ysource) {
    		if (xsource < inner)
       			(xsource < -inner ) ? (amp[0]=0.) : (amp[0]=amp[1]=0.);
    		else
       			amp[1] = 0.;
   		}
}
timeset() 
{}
mroom()
{}
